#include "Log.h"
#include <iostream>

int main() {

	Log::init();
	Log::info << "Hello World!";

	Log::addLogfile("test.warn.log", Log::Level::WARN);
	Log::addLogfile("test.info.log", Log::Level::INFO, Log::Level::INFO);
	Log::addLogfile("test.trace.log", Log::Level::DEBUG, Log::Level::TRACE);

	// log single values only
	std::cout << "=== Log level TRACE ===" << std::endl;
	Log::setConsoleLogLevel(Log::Level::TRACE);
	Log::trace << "trace msg @Lvl TRACE";
	Log::debug << "dbg   msg @Lvl TRACE";
	Log::info << "info  msg @Lvl TRACE";
	Log::note << "note  msg @Lvl TRACE";
	Log::warn << "warn  msg @Lvl TRACE";
	Log::error << "error msg @Lvl TRACE";
	Log::fatal << "fatal msg @Lvl TRACE";

	std::cout << "=== Log level WARN ===" << std::endl;
	Log::setConsoleLogLevel(Log::Level::WARN);
	Log::trace << 42;
	Log::debug << 42;
	Log::info << 42;
	Log::note << 42;
	Log::warn << 42;
	Log::error << 42;
	Log::fatal << 42;

	std::cout << "=== Log level FATAL ===" << std::endl;
	Log::setConsoleLogLevel(Log::Level::FATAL);
	Log::trace << 3.14159;
	Log::debug << 3.14159;
	Log::info << 3.14159;
	Log::note << 3.14159;
	Log::warn << 3.14159;
	Log::error << 3.14159;
	Log::fatal << 3.14159;

	// log streams + colors
	Log::setColoredOutput(true);
	Log::setConsoleLogLevel(Log::Level::TRACE);
	std::cout << "=== Log level DEBUG ===" << std::endl;
	Log::trace << "trace msg @Lvl TRACE; " << 42 << "; " << 3.14159;
	Log::debug << "dbg   msg @Lvl TRACE; " << 42 << "; " << 3.14159;
	Log::info  << "info  msg @Lvl TRACE; " << 42 << "; " << 3.14159;
	Log::note  << "note  msg @Lvl TRACE; " << 42 << "; " << 3.14159;
	Log::warn  << "warn  msg @Lvl TRACE; " << 42 << "; " << 3.14159;
	Log::error << "error msg @Lvl TRACE; " << 42 << "; " << 3.14159;
	Log::fatal << "fatal msg @Lvl TRACE; " << 42 << "; " << 3.14159;

	std::cout << "=== Log level WARN ===" << std::endl;
	Log::setConsoleLogLevel(Log::Level::WARN);
	Log::trace << "trace msg @Lvl WARN;  " << 42 << "; " << 3.14159;
	Log::debug << "dbg   msg @Lvl WARN;  " << 42 << "; " << 3.14159;
	Log::info  << "info  msg @Lvl WARN;  " << 42 << "; " << 3.14159;
	Log::note  << "note  msg @Lvl WARN;  " << 42 << "; " << 3.14159;
	Log::warn  << "warn  msg @Lvl WARN;  " << 42 << "; " << 3.14159;
	Log::error << "error msg @Lvl WARN;  " << 42 << "; " << 3.14159;
	Log::fatal << "fatal msg @Lvl WARN;  " << 42 << "; " << 3.14159;

	std::cout << "=== Log level FATAL ===" << std::endl;
	Log::setConsoleLogLevel(Log::Level::FATAL);
	Log::trace << "trace msg @Lvl FATAL; " << 42 << "; " << 3.14159;
	Log::debug << "dbg   msg @Lvl FATAL; " << 42 << "; " << 3.14159;
	Log::info  << "info  msg @Lvl FATAL; " << 42 << "; " << 3.14159;
	Log::note  << "note  msg @Lvl FATAL; " << 42 << "; " << 3.14159;
	Log::warn  << "warn  msg @Lvl FATAL; " << 42 << "; " << 3.14159;
	Log::error << "error msg @Lvl FATAL; " << 42 << "; " << 3.14159;
	Log::fatal << "fatal msg @Lvl FATAL; " << 42 << "; " << 3.14159;

	Log::stop();

	return 0;
}